from collectionviews.iterables import ComposedIterablesBase, UnitedIterablesMixin
from collectionviews.filtered import FilteredIterablesMixin


class ComposedListsBase(ComposedIterablesBase):

    def count(self, value):
        pass  # todo

    def index(self, value, start=None, stop=None):
        return list(self).index(value, start, stop)

    def __len__(self):
        return len(list(iter(self)))

    def __contains__(self, item):
        return item in iter(self)

    def __getitem__(self, y):
        if isinstance(y, slice):
            return list(self)[y]
        if not isinstance(y, int):
            raise TypeError("list indices must be integers, not %s" % type(y))
        if y < 0:
            y = self.__len__() + y
        i = 0
        iterator = iter(self)
        while i < y:
            next(iterator)
            i += 1
        return next(iterator)


class JoinedLists(ComposedListsBase):
    pass


class UnitedLists(UnitedIterablesMixin, ComposedListsBase):
    pass


class FilteredLists(FilteredIterablesMixin, ComposedListsBase):

    def __init__(self, filter, *sources, filters=None, conjunction=FilteredIterablesMixin.ConjunctionType.AND):
        FilteredIterablesMixin.__init__(self, filter, filters=filters, conjunction=conjunction)
        ComposedListsBase.__init__(self, *sources)


class FilteredUnitedLists(UnitedIterablesMixin, FilteredIterablesMixin, ComposedListsBase):

    def __init__(self, filter, *sources, filters=None, conjunction=FilteredIterablesMixin.ConjunctionType.AND):
        FilteredIterablesMixin.__init__(self, filter, filters=filters, conjunction=conjunction)
        ComposedListsBase.__init__(self, *sources)
