
class DictSlicingMixin(object):

    ANYKEY = object()
    EMPTYKEY = object()

    def __init__(self, blade, blades=None):
        super(DictSlicingMixin, self).__init__()
        self._blades = [blade, ]
        if blades:
            self._blades.extend(blades)
        if DictSlicingMixin.ANYKEY in self._blades:
            self._blades = DictSlicingMixin.ANYKEY

    def _slice(self, item):
        if self._blades == DictSlicingMixin.ANYKEY or item[0] in self._blades:
            try:
                yield from item[1].items()
            except AttributeError:
                yield (DictSlicingMixin.EMPTYKEY, item[1])

    def _generator(self):
        for item in super(DictSlicingMixin, self)._generator():
            yield from self._slice(item)
